Lines Matching +full:sub +full:- +full:function
3 # Copyright (c) 2006-2015 Devin Teske
57 # Please note that the character ranges A-Z and a-z should be avoided because
59 # For example, A-Z matches any character that sorts after A but before Z,
63 VALID_VARNAME_CHARS="0-9ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz_"
67 # f_clean_env [ --except $varname ... ]
71 # `--except' is required to enable the exclusion-list as the remainder of
76 # within a sub-shell block "(...)" or "$(...)" or "`...`".
83 # Should we process an exclusion-list?
85 if [ "$1" = "--except" ]; then
91 # Loop over a list of variable names from set(1) built-in.
93 for var in $( set | awk -F= \
95 | grep -v '^except$'
98 # In POSIX bourne-shell, attempting to unset(1) OPTIND results
104 # Process the exclusion-list?
119 # Get a system configuration setting from the collection of system-
123 # NOTE: Additional shell parameter-expansion formats are supported. For
131 [ -f "$RC_DEFAULTS" -a -r "$RC_DEFAULTS" ] || return $FAILURE
133 # Taint-check variable name
135 [0-9]*)
142 ( # Execute within sub-shell to protect parent environment
148 f_clean_env --except IFS RC_CONFS RC_DEFAULTS
184 if [ "$1" = "rc_conf_files" -a \
185 "$_rc_confs_set" -a \
197 # This must be the last functional line for both the sub-shell
198 # and the function to preserve the return status from formats
206 # f_sysrc_service_configs [-a|-p] $name [$var_to_set]
219 # If `-a' flag is given and $var_to_set is non-NULL, append result to value of
222 # If `-p' flag is given and $var_to_set is non-NULL, prepend result to value of
225 # NB: The `-a' and `-p' option flags are mutually exclusive.
238 shift $(( $OPTIND - 1 ))
240 [ $# -gt 0 ] || return $FAILURE
246 [ -f "$__spath" -a -x "$__spath" ] || __spath= continue
251 __stype=$( file -b "$__spath" 2> /dev/null )
254 __names=$( exec 9<&1 1>&- 2>&-
278 [ -d "$__test_path" ] ||
281 [ -f "$__test_path" ] || continue
290 [ "$__append" -o "$__prepend" ] &&
310 [ -f "$RC_DEFAULTS" -a -r "$RC_DEFAULTS" ] || return $FAILURE
312 # Taint-check variable name
314 [0-9]*)
321 ( # Execute within sub-shell to protect parent environment
327 f_clean_env --except RC_DEFAULTS
335 # This must be the last functional line for both the sub-shell
336 # and the function to preserve the return status from formats
346 # Find which file holds the effective last-assignment to a given variable
349 # If the variable is found in any of the rc.conf(5) files, the function prints
351 # NULL and the function returns with error status.
363 ""|[0-9]*) return $FAILURE
374 # these in order, so we will search them in reverse-order to find the
375 # last-assignment -- the one that ultimately effects the environment).
392 [ -f "$file" -a -r "$file" ] || continue
393 if grep -Eq "$regex" $file; then
407 # Multi-line comments are joined together. Results are NULL if no description
410 # This function is a two-parter. Below is the awk(1) portion of the function,
411 # afterward is the sh(1) function which utilizes the below awk script.
415 # -v varname="varname"
428 sub(/^[^#]*(#[[:space:]]*)?/, "")
438 sub(/(.*#)*[[:space:]]*/, "")
443 sub(/^[[:space:]]*/, "", buffer)
444 sub(/[[:space:]]*$/, "", buffer)
452 awk -v varname="$1" "$f_sysrc_desc_awk" < "$RC_DEFAULTS"
457 # Change a setting in the system configuration files (edits the files in-place
462 # This function is a two-parter. Below is the awk(1) portion of the function,
463 # afterward is the sh(1) function which utilizes the below awk script.
467 # -v varname="varname"
468 # -v new_value="new_value"
483 matchlen = RSTART + RLENGTH - 1
486 value = substr($0, matchlen + 1, length($0) - matchlen)
491 # Assignment w/ back-ticks, expression, or misc.
496 # Assignment w/ single-quoted value
498 sub(/^'\''[^'\'']*/, "", value)
500 sub(/^'\''/, "", value)
503 # Assignment w/ double-quoted value
505 sub(/^"(.*\\\\+")*[^"]*/, "", value)
507 sub(/^"/, "", value)
510 # Assignment w/ non-quoted value
513 sub(/^[^[:space:]]*/, "", value)
516 # Null-assignment
533 # Find which rc.conf(5) file contains the last-assignment
537 if [ "$file" = "$RC_DEFAULTS" -o ! "$file" ]; then
562 [ ! -e "$file" ] || awk 'BEGIN { wc = 0 } NR == 1 {
563 (cmd = "wc -l " FILENAME) | getline
575 if [ ! -w "$file" ]; then
585 if ! f_eval_catch -dk tmpfile $funcname mktemp 'mktemp -t "%s"' "$pgm"
598 f_eval_catch -dk mode $funcname stat 'stat -f "%%#Lp" "%s"' "$file" ||
600 f_eval_catch -d $funcname chmod 'chmod "%s" "%s"' "$mode" "$tmpfile"
605 # permissions (so we throw stderr into the bit-bucket).
608 f_eval_catch -dk owner $funcname stat \
609 'stat -f "%%u:%%g" "%s"' "$file" || owner="root:wheel"
610 f_eval_catch -d $funcname chown 'chown "%s" "%s"' "$owner" "$tmpfile"
616 # LF will trigger a bug in `tail -r' where last two lines are joined.
619 new_contents=$( awk 1 "$file" 2> /dev/null | tail -r )
620 new_contents=$( echo "$new_contents" | awk -v varname="$varname" \
621 -v new_value="$new_value" "$f_sysrc_set_awk" )
627 echo "$new_contents" | tail -r > "$tmpfile" || return $FAILURE
628 if [ $retval -ne $SUCCESS ]; then
633 # Taint-check our results.
635 if ! f_eval_catch -d $funcname sh '/bin/sh -n "%s"' "$tmpfile"; then
637 rm -f "$tmpfile"
644 f_eval_catch -de $funcname mv 'mv "%s" "%s"' "$tmpfile" "$file"
649 # Remove a setting from the system configuration files (edits files in-place).
651 # `-f file' option is passed, the removal is restricted to only those files
654 # This function is a two-parter. Below is the awk(1) portion of the function,
655 # afterward is the sh(1) function which utilizes the below awk script.
659 # -v varname="varname"
686 for file in ${RC_CONFS-$( f_sysrc_get rc_conf_files )}; do
687 [ -e "$file" ] || continue
692 if ! f_eval_catch -dk tmpfile $funcname mktemp \
693 'mktemp -t "%s"' "$pgm"
704 f_eval_catch -dk mode $funcname stat \
705 'stat -f "%%#Lp" "%s"' "$file" || mode=0644
706 f_eval_catch -dk owner $funcname stat \
707 'stat -f "%%u:%%g" "%s"' "$file" || owner="root:wheel"
708 f_eval_catch -d $funcname chmod \
710 f_eval_catch -d $funcname chown \
717 awk -v varname="$varname" "$f_sysrc_delete_awk" "$file" \
719 if [ $? -ne $SUCCESS ]; then
721 rm -f "$tmpfile"
726 # Taint-check our results.
728 if ! f_eval_catch -d $funcname sh '/bin/sh -n "%s"' "$tmpfile"
732 rm -f "$tmpfile"
739 if [ ! -w "$file" ]; then
741 rm -f "$tmpfile"
748 f_eval_catch -de $funcname mv \